## sgb 1999.08.20

=== Makefile ===
#
#   Makefile for the Stanford GraphBase
#

#   Be sure that CWEB version 3.0 or greater is installed before proceeding!

#   Skip down to "SHORTCUT" if you're going to work only from the
#   current directory. (Not recommended for serious users.)

#   Change SGBDIR to the directory where all GraphBase files will go:
SGBDIR = /usr/local/sgb

#   Change DATADIR to the directory where GraphBase data files will go:
DATADIR = $(SGBDIR)/data

#   Change INCLUDEDIR to the directory where GraphBase header files will go:
INCLUDEDIR = $(SGBDIR)/include

#   Change LIBDIR to the directory where GraphBase library routines will go:
LIBDIR = /usr/local/lib

#   Change BINDIR to the directory where installdemos will put demo programs:
BINDIR = /usr/local/bin

#   Change CWEBINPUTS to the directory where CWEB include files will go:
CWEBINPUTS = /usr/local/lib/cweb

#   SHORTCUT: Uncomment these lines, for single-directory installation:
#DATADIR = .
#INCLUDEDIR = .
#LIBDIR = .
#BINDIR = .
#CWEBINPUTS = .

#   Uncomment the next line if your C uses <string.h> but not <strings.h>:
#SYS = -DSYSV

#   If you prefer optimization to debugging, change -g to something like -O:
CFLAGS = -g -I$(INCLUDEDIR) $(SYS)

########## You shouldn't have to change anything after this point ##########

LDFLAGS = -L. -L$(LIBDIR)
LDLIBS = -lgb
LOADLIBES = $(LDLIBS)

.SUFFIXES: .dvi .tex .w

.tex.dvi:
	tex $*.tex

.w.c:
	if test -r $*.ch; then ctangle $*.w $*.ch; else ctangle $*.w; fi

.w.tex:
	if test -r $*.ch; then cweave $*.w $*.ch; else cweave $*.w; fi

.w.o:
	make $*.c
	make $*.o

.w:
	make $*.c
	make $*

.w.dvi:
	make $*.tex
	make $*.dvi

DATAFILES = anna.dat david.dat econ.dat games.dat homer.dat huck.dat \
        jean.dat lisa.dat miles.dat roget.dat words.dat
KERNELFILES = gb_flip.w gb_graph.w gb_io.w gb_sort.w
GENERATORFILES = gb_basic.w gb_books.w gb_econ.w gb_games.w gb_gates.w \
        gb_lisa.w gb_miles.w gb_plane.w gb_raman.w gb_rand.w gb_roget.w \
        gb_words.w
DEMOFILES = assign_lisa.w book_components.w econ_order.w football.w \
        girth.w ladders.w miles_span.w multiply.w queen.w roget_components.w \
        take_risc.w word_components.w
MISCWEBS = boilerplate.w gb_dijk.w gb_save.w gb_types.w test_sample.w
CHANGEFILES = queen_wrap.ch word_giant.ch
MISCFILES = Makefile README abstract.plaintex cities.texmap blank.w \
        sample.correct test.correct test.dat +The+Stanford+GraphBase+
ALL = $(DATAFILES) $(KERNELFILES) $(GENERATORFILES) $(DEMOFILES) \
        $(MISCWEBS) $(CHANGEFILES) $(MISCFILES)

OBJS = $(KERNELFILES:.w=.o) $(GENERATORFILES:.w=.o) gb_dijk.o gb_save.o
HEADERS = $(OBJS:.o=.h)
DEMOS = $(DEMOFILES:.w=)

help:
	@ echo "First 'make tests';"
	@ echo "then (optionally) become superuser;"
	@ echo "then 'make install';"
	@ echo "then (optionally) 'make installdemos';"
	@ echo "then (optionally) 'make clean'."

lib: libgb.a

libgb.a: $(OBJS)
	rm -f certified
	ar rcv libgb.a $(OBJS)
	- ranlib libgb.a

gb_io.o: gb_io.c
	$(CC) $(CFLAGS) -DDATA_DIRECTORY=\"$(DATADIR)/\" -c gb_io.c

test_io: gb_io.o
	$(CC) $(CFLAGS) test_io.c gb_io.o -o test_io

test_graph: gb_graph.o
	$(CC) $(CFLAGS) test_graph.c gb_graph.o -o test_graph

test_flip: gb_flip.o
	$(CC) $(CFLAGS) test_flip.c gb_flip.o -o test_flip

tests: test_io test_graph test_flip
	./test_io
	./test_graph
	./test_flip
	make gb_sort.o
	make lib
	make test_sample
	- ./test_sample > sample.out
	diff test.gb test.correct
	diff sample.out sample.correct
	rm test.gb sample.out test_io test_graph test_flip test_sample
	echo "Congratulations --- the tests have all been passed."
	touch certified

install: lib
	if test ! -r certified; then echo "Please run 'make tests' first!"; fi
	test -r certified
	make installdata
	- mkdir $(LIBDIR)
	- cp libgb.a $(LIBDIR)
	- mkdir $(CWEBINPUTS)
	- cp -p boilerplate.w gb_types.w $(CWEBINPUTS)
	- mkdir $(INCLUDEDIR)
	- cp -p $(HEADERS) Makefile $(INCLUDEDIR)

installdata: $(DATAFILES)
	- mkdir $(SGBDIR)
	- mkdir $(DATADIR)
	- cp -p $(DATAFILES) $(DATADIR)

installdemos: lib $(DEMOS)
	- mkdir $(BINDIR)
	- mv $(DEMOS) $(BINDIR)

uninstalldemos:
	- cd $(BINDIR); rm -f $(DEMOS)

doc:
	tex abstract.plaintex

clean:
	rm -f *~ *.o *.c *.h libgb.a certified \
	         *.tex *.log *.dvi *.toc *.idx *.scn core

veryclean: clean
	rm -f $(DEMOS)

sgb.tar: $(ALL)
	tar cvf sgb.tar $(ALL)

floppy: $(ALL)
	bar cvf /dev/rfd0 $(ALL)
	bar tvf /dev/rfd0
	eject

fullfloppy: $(ALL) ERRATA ANSI AMIGA PROTOTYPES
	bar cvf /dev/rfd0 $(ALL) ERRATA ANSI AMIGA PROTOTYPES
	bar tvf /dev/rfd0
	eject

fulltar: $(ALL) ERRATA ANSI AMIGA PROTOTYPES
	tar cvf sgb.tar $(ALL) ERRATA ANSI AMIGA PROTOTYPES

## sgb 20090810

=== Makefile ===
--- 
+++ 
@@ -168,10 +168,10 @@
 	bar tvf /dev/rfd0
 	eject
 
-fullfloppy: $(ALL) ERRATA ANSI AMIGA PROTOTYPES
-	bar cvf /dev/rfd0 $(ALL) ERRATA ANSI AMIGA PROTOTYPES
+fullfloppy: $(ALL) ERRATA ANSI AMIGA PROTOTYPES MSVC
+	bar cvf /dev/rfd0 $(ALL) ERRATA ANSI AMIGA PROTOTYPES MSVC
 	bar tvf /dev/rfd0
 	eject
 
-fulltar: $(ALL) ERRATA ANSI AMIGA PROTOTYPES
-	tar cvf sgb.tar $(ALL) ERRATA ANSI AMIGA PROTOTYPES
+fulltar: $(ALL) ERRATA ANSI AMIGA PROTOTYPES MSVC
+	tar cvf sgb.tar $(ALL) ERRATA ANSI AMIGA PROTOTYPES MSVC

## sgb 20210202

=== Makefile ===
--- 
+++ 
@@ -77,7 +77,7 @@
         girth.w ladders.w miles_span.w multiply.w queen.w roget_components.w \
         take_risc.w word_components.w
 MISCWEBS = boilerplate.w gb_dijk.w gb_save.w gb_types.w test_sample.w
-CHANGEFILES = queen_wrap.ch word_giant.ch
+CHANGEFILES = queen_wrap.ch word_giant.ch gb_graph-bigalloc.ch
 MISCFILES = Makefile README abstract.plaintex cities.texmap blank.w \
         sample.correct test.correct test.dat +The+Stanford+GraphBase+
 ALL = $(DATAFILES) $(KERNELFILES) $(GENERATORFILES) $(DEMOFILES) \

=== debian/changelog ===
sgb (1:20210202-1) unstable; urgency=medium

  * New upstream version.
  * Build now incorporates the gb_graph-bigalloc.ch change file.

 -- Julian Gilbey <jdg@debian.org>  Sun, 07 Feb 2021 10:50:52 +0000

sgb (1:20090810-3) unstable; urgency=medium

  * Fix FTBFS with split binaries (with thanks to Andreas Beckmann)
    (closes: #981661)
  * Build documentation as PDFs rather than DVI files
  * Request autobuilding (XS-Autobuild: yes)

 -- Julian Gilbey <jdg@debian.org>  Tue, 02 Feb 2021 22:01:42 +0000

sgb (1:20090810-2) unstable; urgency=medium

  * Upgrade packaging standards.
  * Fix FTBFS on bullseye.

 -- Julian Gilbey <jdg@debian.org>  Fri, 29 Jan 2021 13:57:10 +0000

sgb (1:20090810-1) unstable; urgency=low

  * New upstream release (Closes: #438840)
  * Remove sgb-doc -> sgb symlink and rationalise the examples directories
  * Upgrade Standards-Version

 -- Julian Gilbey <jdg@debian.org>  Tue, 27 Oct 2009 14:32:26 +0000

sgb (1:20050409-2) unstable; urgency=low

  * Fix watch file and clean target of rules file

 -- Julian Gilbey <jdg@debian.org>  Tue,  7 Nov 2006 05:53:32 +0000

sgb (1:20050409-1) unstable; urgency=low

  * New upstream release (documentation corrections only)
  * No longer make sgb-src transition package (Closes: #308712)
  * Update dependencies to refer to texlive as well as tetex
  * Update copyright file with new download location and create
    debian/watch file
  * Make sure we use string.h not strings.h

 -- Julian Gilbey <jdg@debian.org>  Wed,  1 Nov 2006 21:56:14 +0000

sgb (1:20030623-3) unstable; urgency=low

  * Correct manpage (/usr/doc -> /usr/share/doc) (closes: #283980)

 -- Julian Gilbey <jdg@debian.org>  Tue, 22 Feb 2005 21:42:10 +0000

sgb (1:20030623-2) unstable; urgency=high

  * Fixes RC FTBFS bug: Makefile.debian used -lgb instead of libgb.a
    (closes: #263943)

 -- Julian Gilbey <jdg@debian.org>  Wed, 11 Aug 2004 10:23:11 -0400

sgb (1:20030623-1) unstable; urgency=low

  * New upstream version
  * Use ANSI prototypes throughout (closes: #217429)

 -- Julian Gilbey <jdg@debian.org>  Mon, 27 Oct 2003 22:32:19 +0000

sgb (1:20020726-2) unstable; urgency=low

  * Update dependencies post-cweb transition

 -- Julian Gilbey <jdg@debian.org>  Wed,  5 Mar 2003 16:18:59 +0000

sgb (1:20020726-1) unstable; urgency=low

  * New upstream version
  * MOVED TO NON-FREE: should always have been there, as the license does
    not permit redistribution of modified sources/binaries.

 -- Julian Gilbey <jdg@debian.org>  Thu,  3 Oct 2002 21:48:51 +0100

sgb (1:20020130-1) unstable; urgency=low

  * New upstream version

 -- Julian Gilbey <jdg@debian.org>  Wed, 20 Mar 2002 16:42:50 +0000

sgb (1:20010107-4) unstable; urgency=low

  * Changed priority to extra, as per ftp-maintainers' request.
  * Add some lintian overrides
  * Move to build-arch/build-indep in debian/rules
  * debhelper v.3

 -- Julian Gilbey <jdg@debian.org>  Wed, 16 Jan 2002 12:47:43 +0000

sgb (1:20010107-3) unstable; urgency=low

  * Recompiled with new CWEBINPUTS directory for new kpathsea-enabled
    CWEB.

 -- Julian Gilbey <jdg@debian.org>  Tue, 15 Jan 2002 03:34:44 +0000

sgb (1:20010107-2) unstable; urgency=low

  * Realised that as the upstream source is never going to change the
    library interface, the soname should never need to be changed.  So
    reverting to soname of libgb.so.1, and leaving it there.

 -- Julian Gilbey <jdg@debian.org>  Mon, 14 May 2001 15:46:07 +0100

sgb (1:20010107-1) unstable; urgency=low

  * New upstream release

 -- Julian Gilbey <jdg@debian.org>  Tue,  8 May 2001 10:21:59 +0100

sgb (1:20000914-5) unstable; urgency=low

  * Remove the -Wl,-lc option; Ben Collins told me it's not necessary when
    using gcc
  * Rename the -src package to -doc (the change was not a wise thing to
    do); keep the -src package as a temporary dummy package until after
    woody is released (closes: #94822)

 -- Julian Gilbey <jdg@debian.org>  Fri, 27 Apr 2001 01:34:52 +0100

sgb (1:20000914-4) unstable; urgency=low

  * Removed dangling symlink from /usr/lib caused by bad soname in version
    2000.09.14-1

 -- Julian Gilbey <jdg@debian.org>  Mon,  2 Apr 2001 21:04:49 +0100

sgb (1:20000914-3) unstable; urgency=low

  * Renumber package version according to policy (YYYYMMDD, not
    YYYY.MM.DD); oops.
  * Rename sgb-doc as sgb-src

 -- Julian Gilbey <jdg@debian.org>  Wed, 21 Feb 2001 00:42:20 +0000

sgb (1:2000.09.14-2) unstable; urgency=low

  * Correct versioning information in library
  * Add support for DEB_BUILD_OPTIONS
  * Standards version 3.5.0
  * Added ldconfig call in postrm

 -- Julian Gilbey <jdg@debian.org>  Thu, 15 Feb 2001 01:32:07 +0000

sgb (1:2000.09.14-1) unstable; urgency=low

  * New upstream version

 -- Julian Gilbey <jdg@debian.org>  Thu,  7 Dec 2000 21:09:04 +0000

sgb (1:1999.08.20-8) unstable; urgency=low

  * Have another attempt at removing this symlink, this time it's
    /usr/doc/sgb-doc/examples/examples.  (closes: #58879)

 -- Julian Gilbey <jdg@debian.org>  Thu, 11 May 2000 12:23:13 +0100

sgb (1:1999.08.20-7) unstable; urgency=low

  * Get rid of spurious /usr/share/doc/sgb-doc/examples/examples symlink
    if it exists (closes: #51102)

 -- Julian Gilbey <jdg@debian.org>  Thu, 25 Nov 1999 21:12:06 +0000

sgb (1:1999.08.20-6) unstable; urgency=low

  * Upgrade to Standards version 3.1.1.
  * Make sure to call debhelper autoscripts from maintainer scripts.

 -- Julian Gilbey <jdg@debian.org>  Wed, 24 Nov 1999 21:52:58 +0000

sgb (1:1999.08.20-5) unstable; urgency=low

  * debian/rules should use Makefile.debian for the "clean" target
    (spotted by Roman Hodek)
  * Use -O1 to try to correct the m68k problem instead

 -- Julian Gilbey <jdg@debian.org>  Wed,  8 Sep 1999 00:10:35 +0100

sgb (1:1999.08.20-4) unstable; urgency=low

  * Tried to correct debian.rules again.  This time, compile will use
    -fno-strict-aliasing for all versions of gcc >= 2.95.  And the flag is
    actually used!



=== debian/control ===
Source: sgb
Section: non-free/math
Priority: optional
Maintainer: Julian Gilbey <jdg@debian.org>
Standards-Version: 4.5.1
Build-Depends: debhelper-compat (= 13),
               texlive-base,
               texlive-base-bin,
               texlive-extra-utils
Homepage: https://www-cs-faculty.stanford.edu/~knuth/sgb.html
Vcs-Git: https://salsa.debian.org/debian/sgb.git
Vcs-Browser: https://salsa.debian.org/debian/sgb
Rules-Requires-Root: no
XS-Autobuild: yes

Package: sgb
Architecture: any
Depends: ${misc:Depends}, ${shlibs:Depends}
Recommends: c-compiler, texlive-base, texlive-base-bin, texlive-extra-utils
Suggests: sgb-doc (>= ${binary:Version})
Description: The Stanford GraphBase: combinatorial data and algorithms
 A highly portable collection of programs and data for researchers who
 study combinatorial algorithms and data structures.
 .
 The programs are intended to be interesting in themselves as examples
 of literate programming.  Thus, the Stanford GraphBase can also be
 regarded as a collection of approximately 30 essays for programmers
 to enjoy reading, whether or not they are doing algorithmic research.
 The programs are written in CWEB, a combination of TeX and C that is
 easy to use by anyone who knows those languages and easy to read by
 anyone familiar with the rudiments of C.
 .
 This package contains only the libraries and the demonstration
 programs; for the readable source code, which forms the documentation
 as well, see the sgb-doc package.

Package: sgb-doc
Architecture: all
Section: non-free/doc
Depends: ${misc:Depends}
Recommends: sgb, texlive-base | texlive-base-bin
Replaces: sgb-src (<= 1:2000.09.14-4)
Conflicts: sgb (<< 1:20090810-1)
Description: Documentation for the Stanford GraphBase
 This package contains the source code for the GraphBase library, which
 forms the major documentation of the package.  It will be installed in
 /usr/share/doc/sgb/src.
 .
 The source code is written in CWEB, a combination of TeX and C, using a
 very readable literate programming style, making the code a joy to read.

=== debian/rules ===
#!/usr/bin/make -f

include /usr/share/dpkg/pkg-info.mk
include /usr/share/dpkg/buildflags.mk
sgbdir=debian/sgb
sgbdocdir=debian/sgb-doc
fullsgbdir=$(CURDIR)/$(sgbdir)

%:
	dh $@


# We apply the PROTOTYPES to the package
execute_before_dh_auto_build:
	cp PROTOTYPES/*.ch .
	for i in gb_io gb_graph gb_gates; do mv $${i}.ch $${i}_proto.ch; done
	ctie -c gb_io.ch gb_io.w gb_io_proto.ch gb_io_headers.ch
	ctie -c gb_graph.ch gb_graph.w gb_graph_proto.ch gb_graph_headers.ch gb_graph-bigalloc.ch
	ctie -c gb_gates.ch gb_gates.w gb_gates_proto.ch gb_gates_printf.ch

override_dh_auto_build:
	$(MAKE) -f Makefile.debian CFLAGS='$(CFLAGS) -Wall -D_REENTRANT -I.' VERSION=$(DEB_VERSION_UPSTREAM) tests
	rm -f *.o
	$(MAKE) -f Makefile.debian CFLAGS='$(CFLAGS) -Wall -fPIC -D_REENTRANT -I.' VERSION=$(DEB_VERSION_UPSTREAM) sotests
	$(MAKE) -f Makefile.debian demos
	$(MAKE) -f Makefile.debian doc

override_dh_auto_clean:
	$(MAKE) -f Makefile.debian veryclean
	rm -f $$(cd PROTOTYPES && echo *.ch)
	rm -f gb_io_proto.ch gb_graph_proto.ch gb_gates_proto.ch

override_dh_auto_install-arch:
	$(MAKE) -f Makefile.debian install
	#  We make appropriate links for the dynamic library
	cd $(sgbdir)/usr/lib && mv libgb.so libgb.so.1.$(DEB_VERSION_UPSTREAM) && \
	  ln -s libgb.so.1.$(DEB_VERSION_UPSTREAM) libgb.so.1 && \
	  ln -s libgb.so.1.$(DEB_VERSION_UPSTREAM) libgb.so

override_dh_auto_install-indep:

execute_after_dh_installexamples-indep:
	mv $(sgbdocdir)/usr/share/doc/sgb/examples/Makefile.doc \
	  $(sgbdocdir)/usr/share/doc/sgb/examples/Makefile

override_dh_makeshlibs:
	dh_makeshlibs -a -V 'sgb (>= 1:20010107-2)'

=== debian/watch ===
version=3
opts="uversionmangle=s/-//g" \
  http://ftp.cs.stanford.edu/pub/sgb/sgb-(\d+-\d+-\d+)\.tar\.gz
